# This file was automatically generated by SWIG (https://www.swig.org).
# Version 4.1.1
#
# Do not make changes to this file unless you know what you are doing - modify
# the SWIG interface file instead.

from sys import version_info as _swig_python_version_info
# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _sdm
else:
    import _sdm

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "this":
            set(self, name, value)
        elif name == "thisown":
            self.this.own(value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


class sdm(object):
    r"""Proxy of C++ casac::sdm class."""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args, **kwargs):
        r"""__init__(self, _path=string("")) -> sdm"""
        _sdm.sdm_swiginit(self, _sdm.new_sdm(*args, **kwargs))

    def summarystr(self):
        r"""
        summarystr(self) -> string


        Summary:
            Returns a summary of the SDM as a string

        --------------------------------------------------------------------------------

        """
        return _sdm.sdm_summarystr(self)

    def fromms(self, *args, **kwargs):
        r"""
        fromms(self, _mspath=string(""), _datacolumn=string("DATA"), _archiveid=string("S0"), _rangeid=string("X1"), _subscanduration=double(24.0*3600.0), _sbduration=double(2700.0), _apcorrected=bool(false), _verbose=bool(true)) -> bool


        Summary:
            convert measurement set into an SDM (stored path)

        Description:


        Create an sdm object with a non-existant path, and then use this function to populate
        the directory (which will be created) with the specified measurement set.


        Input Parameters:
            mspath                    Path to the MS to import
            datacolumn                 specifies which of the MS data columns (DATA, CORRECTED_DATA, or MODEL_DATA) should be used as the visibilities in the ASDM 
            archiveid                  the X0 in uid://X0/X1/X<running> 
            rangeid                    the X1 in uid://X0/X1/X<running> 
            subscanduration            maximum duration of a subscan in the output ASDM 
            sbduration                 maximum duration of a scheduling block in the output ASDM 
            apcorrected                If true, the data in column datacolumn should be regarded as having atmospheric phase correction 
            verbose                   produce log output

        --------------------------------------------------------------------------------

        """
        return _sdm.sdm_fromms(self, *args, **kwargs)

    def toms(self, *args, **kwargs):
        r"""
        toms(self, _vis=string(""), _createmms=bool(false), _separationaxis=string("auto"), _numsubms=variant( ), _corr_mode=string("all"), _srt=string("all"), _time_sampling=string("all"), _ocorr_mode=string("ca"), _compression=bool(false), _lazy=bool(false), _asis=string(""), _wvr_corrected_data=string("no"), _scans=string(""), _ignore_time=bool(false), _process_syspower=bool(true), _process_caldevice=bool(true), _process_pointing=bool(true), _process_flags=bool(true), _tbuff=double(0.0), _applyflags=bool(false), _savecmds=bool(false), _outfile=variant( ), _flagbackup=bool(true), _verbose=bool(false), _overwrite=bool(false), _bdfflags=bool(false), _with_pointing_correction=bool(false), _convert_ephem2geo=bool(true), _polyephem_tabtimestep=double(0.)) -> bool


        Summary:
            Convert a Science Data Model observation into a CASA visibility file (MS)

        Input Parameters:
            vis                       Root name of the ms to be created. Note the .ms is NOT added
            createmms                 Create a Multi-MS output
            separationaxis            Axis to do parallelization across(scan, spw, baseline, auto)
            numsubms                  The number of SubMSs to create (auto or any number)
            corr_mode                 specifies the correlation mode to be considered on input. A quoted string containing a sequence of ao, co, ac,or all separated by whitespaces is expected
            srt                       specifies the spectral resolution type to be considered on input. A quoted string containing a sequence of fr, ca, bw, or all separated by whitespaces is expected
            time_sampling             specifies the time sampling (INTEGRATION and/or SUBINTEGRATION)  to be considered on input. A quoted string containing a sequence of i, si, or all separated by whitespaces is expected
            ocorr_mode                output data for correlation mode AUTO_ONLY (ao) or CROSS_ONLY (co) or CROSS_AND_AUTO (ca)
            compression               Flag for turning on data compression
            lazy                      Make the MS DATA column read the ASDM Binary data directly (faster import, smaller MS)
            asis                      Creates verbatim copies of the ASDMtables in the ouput measurement set.  Value given must be a string of table names separated by spaces; A * wildcard is allowed.
            wvr_corrected_data        Specifies which values are considerd in the SDM binary data to fill the DATA column in the MAIN table of the MS. Expected values for this option are: no, for uncorrected data (default), yes, for the corrected data, and both, for for corrected and uncorrected data. Note if both is selected two measurement sets are created, one with uncorrected data and the other with corrected data.
            scans                     processes only the specified scans. This value is a semicolon separated list of scan specifications. A scan specification consists in an exec bock index followed by the : character;  followed by a comma separated list of scan indexes or scan index ranges. A scan index is relative to the exec block it belongs to. Scan indexes are 1-based while exec blocks are 0-based. '0:1' or '2:2~6' or '0:1,1:2~6,8;2:,3:24~30' '1,2' are valid values for the option. '3:' alone will be interpreted as, all the scans of the exec block#3.  An scan index or a scan index range not preceded by an exec block index will be interpreted as, all the scans with such indexes in all the exec blocks.  By default all the scans are considered.
            ignore_time               All the rows of the tables Feed, History, Pointing, Source, SysCal, CalDevice, SysPower, and Weather are processed independently of the time range of the selected exec block / scan.
            process_syspower          The SysPower table is processed if and only if this parameter is set to true.
            process_caldevice         The CalDevice table is processed if and only if this parameter is set to true.
            process_pointing          The Pointing table is processed if and only if this parameter is set to true. If set to false, the POINTING table is empty in the resulting MS
            process_flags             Create online flags in the FLAG_CMD sub-table.
            tbuff                     Time padding buffer (seconds)
            applyflags                Apply the flags to the MS.
            savecmds                  Save flag commands to an ASCII file
            outfile                   Name of ASCII file to save flag commands
            flagbackup                Back up flag column before applying flags.
            verbose                   Output lots of information while the filler is working
            overwrite                 Over write an existing MS(s)
            bdfflags                  Set the MS FLAG column according to the ASDM _binary_ flags
            with_pointing_correction  add (ASDM::Pointing::encoder - ASDM::Pointing::pointingDirection) to the value to be written in MS::Pointing::direction
            convert_ephem2geo         if true, convert any attached ephemerides to the GEO reference frame (time-spacing not changed)
            polyephem_tabtimestep     Timestep (days) for the tabulation of polynomial ephemerides. A value <= 0 disables tabulation.

        --------------------------------------------------------------------------------

        """
        return _sdm.sdm_toms(self, *args, **kwargs)
    __swig_destroy__ = _sdm.delete_sdm

# Register sdm in _sdm:
_sdm.sdm_swigregister(sdm)

